function  out_file = awgn(in_file, fs, varargin )

global SNR NIST WHITE_NOISE

if nargin >= 3
    x1 = varargin{1};
    x2 = varargin{2};
end

rng default
len_sound = length(in_file);
if NIST
    if WHITE_NOISE
        noise = 0.005 * randn(len_sound, 1);
        out_file = in_file;
        
        if nist_stnr_m(out_file, fs) < SNR
            disp('The desired SNR value is too high') %%% org. "The wanted SNR value is too low"
            return
        end
        
        i = 1;
        if SNR > 5
            while nist_stnr_m(out_file, fs) > SNR && i < 50
                out_file = in_file + (0.05 * i * noise);
                i = i + 1;
            end
        else
            SNR1 = 10^(nist_stnr_m(in_file, fs) / 10); % SNR for the original sound file
            n_2 = 0.005 * randn(len_sound, 1);
            var_n2 = var(n_2, 1);
            y_2 = in_file + n_2;
            SNR2 = 10^(nist_stnr_m(y_2, fs) / 10);
            var_s = (SNR1 * SNR2 * var_n2) / (SNR1 - SNR2);
            SNR3 = -10 * log10((1 / SNR1) + (var(noise) / var_s));
            wanted_var_n3 = var_s * (10^(-SNR / 10) - (1 / SNR1));
            alpha = abs(sqrt(wanted_var_n3 / var(noise)));
            out_file = in_file + (alpha * noise);
        end
    else
        noise = wavread('../../Databases/recordings/recordings_klotski/noises/background.wav');
        len_noise = length(noise);
        noise = repmat(noise,ceil(len_sound/len_noise),1);
        noise = noise(1:len_sound);
        
        SNR1 = 10^(nist_stnr_m(in_file, fs) / 10); % SNR for the original sound file
        n_2 = 0.005 * randn(len_sound, 1);
        var_n2 = var(n_2, 1);
        y_2 = in_file + n_2;
        SNR2 = 10^(nist_stnr_m(y_2, fs) / 10);
        var_s = (SNR1 * SNR2 * var_n2) / (SNR1 - SNR2);
        SNR3 = -10 * log10((1 / SNR1) + (var(noise) / var_s));
        wanted_var_n3 = var_s * (10^(-SNR / 10) - (1 / SNR1));
        alpha = abs(sqrt(wanted_var_n3 / var(noise)));
        out_file = in_file + (alpha * noise);
    end
else
    if WHITE_NOISE
        if (nargin < 3)
            P_sig = var(x,1);
        else
            P_sig = var([x1; x2; x1], 1);
        end
        P_noise = P_sig * 10^(-SNR/10);
        noise = sqrt(P_noise) * randn(len_sound, 1);
        out_file = in_file + noise;
    else
        noise = wavread('../../Databases/recordings/recordings_klotski/noises/background.wav');
        len_noise = length(noise);
        noise = repmat(noise,ceil(len_sound/len_noise),1);
        noise = noise(1:len_sound);
        if (nargin < 3)
            P_sig = var(x,1);
        else
            P_sig = var([x1; x2; x1], 1);
        end
        P_noise = P_sig * 10^(-SNR/10) / var(noise, 1);
        noise = sqrt(P_noise) * noise;
        out_file = in_file + noise;
    end
end