function speech_flags = ituVad(x_new)

% Main file for the ITU G.729 B algortihm

CActive = 1;
CSilence = 0;
CSID = 2;

Ns = length(x_new);

NsFrame = 80;       % Frame size (10ms)
NsLA = 40;          % Look-ahead size for VAD / DTX 
NsWin = 240;        % <----------------------------
NFrame = floor(Ns/NsFrame);

% Append zeros to input data (to allow look-ahead for the last frame)
x_new = [x_new; zeros(NsFrame, 1)];

% Initialize the VAD and DTX
VADPar = InitVADPar;

speech_flags = zeros(1, NFrame);

for k = 0 : NFrame-1

  ist = k * NsFrame + 1;
  ifn = ist + NsFrame - 1;       % New data limits

  % VAD / DTX
  x_frame = x_new(ist : ifn);
  [Ivd, VADPar] = itu_vad(x_frame, VADPar);
  
  speech_flags(k + 1) = Ivd;
  
end

% if plotvads == 0
%     x_flagged2 = zeros(1, length(x),'uint8');
% end
% if plotvads
%     max_x = max(x);
%     for i = 0 : length(speech_flags) - 1
%         x_flagged2(((i * 480) + 1) : ((i * 480) + 480)) = speech_flags(i + 1) * max_x;
%     end
% else
%     for i = 0 : length(speech_flags) - 1
%         x_flagged2(((i * 480) + 1) : ((i * 480) + 480)) = speech_flags(i + 1);
%     end
% end

% if plotvads
%     if concatenate
%         figure(fig)
%         subplot(4,1,2)
%         plot(x_flagged2(length(x_flagged2) / 2 + 1 : length(x_flagged2)),'r')
%         title(['ITU VAD, SNR = ',num2str(snr)])
%         hold on
%         plot(x(1 : length(x) / 2))
%         hold off
%     else
%         figure(fig)
%         subplot(4,1,2)
%         plot(x_flagged2,'r')
%         title(['ITU VAD, SNR = ',num2str(snr)])
%         hold on
%         plot(x)
%         hold off
%     end
% end

