global SNR NIST WHITE_NOISE GAMMA TRANSIENT FEATURE VADDECIDEUPDATE SPF
SNR = 30;
NIST = 1;
WHITE_NOISE = 1;
GAMMA = 0;
TRANSIENT = 1;
FEATURE = 0;

VADDECIDEUPDATE = 0;
SPF = 0.25;


%transThresh = 20; %%% transient threshold (see hlpVAD.m for info)
%threshVector = [0 0.5 0.7 1 2 3 4 5]; %%% (must be same length as _voting_) transient detection is done independently of voting thresholds, and transient thresholds can therefore be varied with the voting
threshVector = [5 10 15 20 25 30 50 70]; %%% (must be same length as _voting_) transient detection is done independently of voting thresholds, and transient thresholds can therefore be varied with the voting

deciGamma = 0.45; %%% sets gamma for use in the_deci_bdy_ function
sohn = 1; %%% also include the Sohn VAD
hlpupd = 1; %%% use the updated HLP VAD with only transient detection on "frozen models"
plotDrifting = 0; %%% show the plots displaying the effects of drifting on the models
plotVersion = 0; %%% 1: plots TNR vs TPR; 2: plots voting thresholds vs TNR/TPR in two subplots; 3: plot both

weights = ones(1,8);
%weights = [10 40 50 45 35 15 5 5];
%weights = weights./sum(weights);

%voting = [0.3, 0.4, 0.5, 0.6, 0.7]; %%% what percentage of sub-bands that must yield "speech" flag for frame to be classified "speech"
theta = 3.5;
num_chnl = 8; % number of subbands used
voting = ((1/num_chnl):(1/num_chnl):1); %%% what percentage of sub-bands that must yield "speech" flag for frame to be classified "speech"
framesz = 160; stpsz = 80; % frame size 20ms, stepsize 10ms
fftsz = 256;
alpha = 0.99;
M = 60;  % number of frames used to initialize the GMM
SRate = 8000;

load filelist_test.mat
load decisions_test_h#_pau_epi.mat

noFiles = 10;
lenV = length(voting);

%[testFiles, transientNames, fs, tranAvgLen] = createTestFiles(noFiles, stpsz); %%% create _noFiles_ test files with transients
tranAvgLen = 50; %%% set to 50 frames (500 ms) (~avg. transient length)
load('testFiles.mat'); %%% loads (and overwrites) _tranAvgLen_ and _testFiles_
fs = testFiles{1}.fs; %%% same for all files
deci = fs / SRate;

if (noFiles ~= length(testFiles))
    noFiles = length(testFiles);
end

%%% PRE-DECLARATION FOR SPEED
correct = cell(1,noFiles);
org = cell(1,noFiles);
fixed = cell(1,noFiles);
dec = cell(1,noFiles);

outgmmVad = cell(lenV,noFiles);
zgmm = cell(lenV,noFiles);
mu_veriGMM = cell(lenV,noFiles);
vari_veriGMM = cell(lenV,noFiles);
bdyGMM = cell(lenV,noFiles);

outhlpVAD = cell(lenV,noFiles);
z = cell(lenV,noFiles);
mu_veriHLP = cell(lenV,noFiles);
vari_veriHLP = cell(lenV,noFiles);
bdyHLP = cell(lenV,noFiles);
mu_transHLP = cell(lenV,noFiles);
vari_transHLP = cell(lenV,noFiles);
wgt_transHLP = cell(lenV,noFiles);

itu_flags = cell(1,noFiles);
if sohn
    sohnflags = cell(1,noFiles);
end

rocs = cell(lenV,noFiles);
fileWeights = zeros(1, noFiles);
rocMat = cell(1,lenV);
rocTot = cell(1,lenV);
%%% /PRE-DECLARATION FOR SPEED

for v = 1:length(voting)
    for i = 1:noFiles
        disp(['Threshold = ', num2str(voting(v)), ', file no. ', num2str(i), '.']); %%% indicator of progress
        x = testFiles{i}.concatenated;
        starts = testFiles{i}.starts;
        stops = testFiles{i}.stops;
        
        xn = awgn(x, fs); %%% add noise
        sig = decimate(xn, deci, 'FIR'); %%% decimate by factor _deci_ (= 2)

        if v == 1
            [correct{i}, org{i}, fixed{i}, dec{i}, flags] = createFrameAnnotation(starts, stops, length(x), framesz, stpsz, deci, fs, testFiles{i}.tranStart, testFiles{i}.tranStop);
        
            fileWeights(i) = length(sig);
            itu_flags{i} = ituVad(sig); %%% yields same result for each iteration of _v_
            if sohn
                [sohnflags_tmp, ~] = vadsohn(sig, SRate, 'na');
                sohnflags{i} = sohnflags_tmp(:,3)';
                clear sohnflags_tmp;
            end
        end
        
        transThresh = threshVector(v);

        [outgmmVad{v,i}, zgmm{v,i}, mu_veriGMM{v,i}, vari_veriGMM{v,i}, bdyGMM{v,i}] = gmmVad(sig, voting(v), transThresh, tranAvgLen, deciGamma);
        if hlpupd  %%% use the updated version of HLP with parameter freeze only for transient detection
            [outhlpVAD{v,i}, z{v,i}, mu_veriHLP{v,i}, vari_veriHLP{v,i}, bdyHLP{v,i}, cdfThreshold, mu_transHLP{v,i}, vari_transHLP{v,i}, wgt_transHLP{v,i}] = hlpVADupd(sig, num_chnl, framesz, stpsz, theta, fftsz, alpha, voting(v), M, weights, transThresh, tranAvgLen, deciGamma);
        else
            [outhlpVAD{v,i}, z{v,i}, mu_veriHLP{v,i}, vari_veriHLP{v,i}, bdyHLP{v,i}] = hlpVAD(sig, num_chnl, framesz, stpsz, theta, fftsz, alpha, voting(v), M, weights, transThresh, tranAvgLen, deciGamma);
        end
        
        if sohn
            rocs{v,i} = makeROC(correct{i}, outgmmVad{v,i}, outhlpVAD{v,i}, itu_flags{i}, flags, sohnflags{i});
        else
            rocs{v,i} = makeROC(correct{i}, outgmmVad{v,i}, outhlpVAD{v,i}, itu_flags{i}, flags);
        end
        %%% rocs{v,i} = [GMM TNR, GMM TPR;
        %%%              HLP TNR, HLP TPR;
        %%%              ITU TNR, ITU TPR;
        %%%              GMMwTR TNR, GMMwTR TPR; %%% with transient detection
        %%%              HLPwTR TNR, HLPwTR TPR]; %%% with transient detection        
        %%%              Sohn TNR, Sohn TPR; %%% only if _sohn_ = 1
    end
    
    if v == 1 %%% same for all voting thresholds
        normFileWeights = fileWeights./sum(fileWeights); %%% normalize file weights (i.e. mutual length of files)
        normFileWeightsMat = repmat(normFileWeights,size(rocs{v,i},1), 1); %%% stack file weights vertically
    end
    rocMat{v} = []; %%% initalize
    for r = 1:noFiles
        rocMat{v} = [rocMat{v}, rocs{v,r}]; %%% concatenate the hit rates
    end
    rocTot{v} = zeros(size(rocMat{v},1), 2); %%% pre-declare
    rocTot{v}(:,1) = sum(rocMat{v}(:,1:2:end).*normFileWeightsMat,2); %%% (file length-weighted) average negative hit rates
    rocTot{v}(:,2) = sum(rocMat{v}(:,2:2:end).*normFileWeightsMat,2); %%% (file length-weighted) average positive hit rates
end

disp('FRRRDIHH, BRUH!');

tnr = zeros(size(rocMat{v},1), lenV); %%% tpr(1,:) = GMM, 2:HLP, 3:ITU, 4:GMMwTR, 5:HLPwTR, (6: Sohn).
tpr = zeros(size(rocMat{v},1), lenV); %%% tpr(1,:) = GMM, 2:HLP, 3:ITU, 4:GMMwTR, 5:HLPwTR, (6: Sohn).
for s = 1:lenV
    tnr(:,s) = rocTot{s}(:,1);
    tpr(:,s) = rocTot{s}(:,2);
end


%%% begin plot:
voteChn = 1:num_chnl;
save(['deciGamma=', num2str(deciGamma), '_SNR=', num2str(SNR), '_hlpupd=', num2str(hlpupd), '_vadDecideUpdate=', num2str(VADDECIDEUPDATE), '_SPF=', num2str(SPF), '_threshVector=[', num2str(threshVector), ']_weights=[', num2str(weights), '].mat'], 'tnr', 'tpr', 'voting', 'voteChn', 'SNR', 'threshVector', 'hlpupd', 'tranAvgLen', 'SPF', 'VADDECIDEUPDATE', 'deciGamma', 'weights');

if plotVersion == 1 || plotVersion == 3
    figure(98)
    plot(tnr(1,:), tpr(1,:), '-bx', 'MarkerEdgeColor','b', 'MarkerSize', 10) %%% GMM
    grid on
    hold on
    plot(tnr(2,:), tpr(2,:), '-md', 'MarkerEdgeColor','m', 'MarkerSize', 10) %%% HLP
    plot(tnr(3,:), tpr(3,:), '-gs', 'MarkerEdgeColor','g', 'MarkerSize', 10) %%% ITU
    if sohn
        plot(tnr(6,:), tpr(6,:), '-r*', 'MarkerEdgeColor','r', 'MarkerSize', 10) %%% Sohn
    end
    rotate = [45 45 45 45 45 45 45 45];
    for t = 1:length(voting)
        text(tnr(2,t), tpr(2,t), ['# = ' num2str(voteChn(t)), ' \rightarrow    '], 'Rotation', rotate(t), 'FontSize', 10, 'HorizontalAlignment', 'right', 'VerticalAlignment', 'middle');
    end
    axis([0 1.05 0 1.05])
    title(['ROC with SNR = ', num2str(SNR), ', transient threshold = [', num2str(threshVector), '], hlpupd = ', num2str(hlpupd), ' and voting = [' num2str(voting), '] and tranAvgLen = ', num2str(tranAvgLen)]);
    xlabel('TNR (True Negative Rate) Non-speech hit rate')
    ylabel('TPR (True Positive Rate) Speech hit rate')
    if sohn
        legend('GMM', 'HLP', 'ITU', 'Sohn', 'Location', 'SouthWest');
    else
        legend('GMM', 'HLP', 'ITU', 'Location', 'SouthWest');
    end
    figure(99)
    plot(tnr(4,:), tpr(4,:), '-r+', 'MarkerEdgeColor','r', 'MarkerSize', 10) %%% GMMTR
    grid on
    hold on
    plot(tnr(5,:), tpr(5,:), '-ko', 'MarkerEdgeColor','k', 'MarkerSize', 10) %%% HLPTR
    rotate = [45 45 45 45 45 45 5 5];
    for t = 1:length(voting)
        text(tnr(5,t), tpr(5,t), ['   \leftarrow T = ' num2str(threshVector(t))], 'Rotation', rotate(t), 'FontSize', 10, 'HorizontalAlignment', 'left', 'VerticalAlignment', 'middle');
    end
    axis([0 1.05 0 1.05])
    title(['ROC with SNR = ', num2str(SNR), ', transient threshold = [', num2str(threshVector), '], hlpupd = ', num2str(hlpupd), ' and voting = [' num2str(voting), '] and tranAvgLen = ', num2str(tranAvgLen)]);
    xlabel('TNR (True Negative Rate) Non-transient hit rate')
    ylabel('TPR (True Positive Rate) Transient hit rate')
    legend('GMM transient detection', 'HLP transient detection', 'Location', 'SouthWest');
end
if plotVersion == 2 || plotVersion == 3
    figure(100)
    subplot(2,1,1)
        plot(voteChn, tnr(1,:), '-bx', 'MarkerEdgeColor','b', 'MarkerSize', 10) %%% GMM
        grid on
        hold on
        plot(voteChn, tnr(2,:), '-md', 'MarkerEdgeColor','m', 'MarkerSize', 10) %%% HLP
        plot(voteChn, tnr(3,:), '-gs', 'MarkerEdgeColor','g', 'MarkerSize', 10) %%% ITU
        if sohn
            plot(voteChn, tnr(6,:), '-r*', 'MarkerEdgeColor','r', 'MarkerSize', 10) %%% Sohn
        end
        axis([0 1.05*num_chnl 0 1.05])
        title(['T(N/P)R vs voting with SNR = ', num2str(SNR), ', transThresh = [', num2str(threshVector), '], hlpupd = ', num2str(hlpupd), ', voting = [' num2str(voting), '] and tranAvgLen = ', num2str(tranAvgLen)]);
        xlabel('Voting threshold (no. of sub-bands)')
        ylabel('TNR (True Negative Rate)')
        if sohn
            legend('GMM', 'HLP', 'ITU', 'Sohn', 'Location', 'SouthWest');
        else
            legend('GMM', 'HLP', 'ITU', 'Location', 'SouthWest');
        end
    subplot(2,1,2)
        plot(voteChn, tpr(1,:), '-bx', 'MarkerEdgeColor','b', 'MarkerSize', 10) %%% GMM
        grid on
        hold on
        plot(voteChn, tpr(2,:), '-md', 'MarkerEdgeColor','m', 'MarkerSize', 10) %%% HLP
        plot(voteChn, tpr(3,:), '-gs', 'MarkerEdgeColor','g', 'MarkerSize', 10) %%% ITU
        if sohn
            plot(voteChn, tpr(6,:), '-r*', 'MarkerEdgeColor','r', 'MarkerSize', 10) %%% Sohn
        end
        axis([0 1.05*num_chnl 0 1.05])
        xlabel('Voting threshold (no. of sub-bands)')
        ylabel('TPR (True Positive Rate)')
        if sohn
            legend('GMM', 'HLP', 'ITU', 'Sohn', 'Location', 'SouthWest');
        else
            legend('GMM', 'HLP', 'ITU', 'Location', 'SouthWest');
        end
    figure(101)
        subplot(2,1,1)
        plot(threshVector, tnr(4,:), '-r+', 'MarkerEdgeColor','r', 'MarkerSize', 10) %%% GMMwTR
        grid on
        hold on
        plot(threshVector, tnr(5,:), '--ko', 'MarkerEdgeColor','k', 'MarkerSize', 10) %%% HLPwTR
        axis([0.95*threshVector(1) 1.05*threshVector(end) 0 1.05])
        title(['T(N/P)R vs transient thresholds with SNR = ', num2str(SNR), ', transThresh = [', num2str(threshVector), '], hlpupd = ', num2str(hlpupd), ', voting = [' num2str(voting), '] and tranAvgLen = ', num2str(tranAvgLen)]);
        xlabel('Transient detection feature threshold')
        ylabel('TNR (True Negative Rate)')
        legend('GMM transient detection', 'HLP transient detection', 'Location', 'SouthWest');
    subplot(2,1,2)
        plot(threshVector, tpr(4,:), '-r+', 'MarkerEdgeColor','r', 'MarkerSize', 10) %%% GMMwTR
        grid on
        hold on
        plot(threshVector, tpr(5,:), '--ko', 'MarkerEdgeColor','k', 'MarkerSize', 10) %%% HLPwTR
        axis([0.95*threshVector(1) 1.05*threshVector(end) 0 1.05])
        xlabel('Transient detection feature threshold')
        ylabel('TPR (True Positive Rate)')
        legend('GMM transient detection', 'HLP transient detection', 'Location', 'SouthWest');
end


if plotDrifting
    v = find(voting == 0.5); %%% first voting threshold
    i = 10; %%% random file
    %%%for k = 1:num_chnl
    for k = 3
        band = k; %%% sub-band to investigate
        if hlpupd
            mu_refHLP = mu_transHLP{v,i}(band,2:2:end);
            vari_refHLP = vari_transHLP{v,i}(band,2:2:end);
            std_refHLP = sqrt(vari_transHLP{v,i}(band,2:2:end));
            mu_refGMM = mu_veriGMM{v,i}(band,2:2:end);
            vari_refGMM = vari_veriGMM{v,i}(band,2:2:end);
            std_refGMM = sqrt(vari_veriGMM{v,i}(band,2:2:end));
        else
            mu_refHLP = mu_veriHLP{v,i}(band,2:2:end);
            vari_refHLP = vari_veriHLP{v,i}(band,2:2:end);
            std_refHLP = sqrt(vari_veriHLP{v,i}(band,2:2:end));
            mu_refGMM = mu_veriGMM{v,i}(band,2:2:end);
            vari_refGMM = vari_veriGMM{v,i}(band,2:2:end);
            std_refGMM = sqrt(vari_veriGMM{v,i}(band,2:2:end));
        end

        figure((band-1)*3 + 1)
        %subplot(3,1,1)
        fr_sig = mean(z{v,i});
        hp(1,:) = plot(fr_sig); hold on; hp(2,:) = plot(outhlpVAD{v,i}, 'r'); hp(3,:) = plot(outgmmVad{v,i}, 'k--'); hp(4,:) = plot(correct{i}, 'g');
        hp(5,:) = plot(bdyHLP{v,i}(:, band), 'y--'); hp(6,:) = plot(bdyGMM{v,i}(:, band), 'g--');
        title('VAD decision');
        legend('Signal energy (mean of all bands)', 'HLP VAD', 'GMM VAD', 'Transcript', 'HLP VAD boundary', 'GMM VAD boundary', 'Location', 'NorthWest');
        xlabel('Frame no.')
        ylabel('Log energy [dB]')
        %subplot(3,1,2)
        figure((band-1)*3 + 2)
        hand(1) = plot(z{v,i}(band,:), 'r'); hold on; hand(2) = plot(mu_refHLP, 'k', 'LineWidth', 2); hand(3) = plot(mu_refGMM, 'b', 'LineWidth', 2);
        hand(4) = plot(mu_refHLP - std_refHLP, 'y--'); plot(mu_refHLP + std_refHLP, 'y--'); hand(5) = plot(mu_refGMM - std_refGMM, 'g--'); plot(mu_refGMM + std_refGMM, 'g--'); %%% investigates sub-band given in variable _band_
        title(['Sub-band ' num2str(band)]);
        xlabel('Frame no.')
        ylabel('Log energy [dB]')
        legend(hand, 'Signal energy', 'Speech mean (HLP)', 'Speech mean (GMM)', 'Speech variance (HLP)', 'Speech variance (GMM)', 'Location', 'NorthWest')
        %subplot(3,1,3)
        figure((band-1)*3 + 3)
        plot(z{v,i}(band,:), 'r'); hold on; plot(mu_refHLP, 'k'); plot(mu_refGMM, 'b');
        plot(bdyHLP{v,i}(:, band), 'y--'); plot(bdyGMM{v,i}(:, band), 'g--');
        plot(outhlpVAD{v,i}, 'r'); plot(outgmmVad{v,i}, 'k--'); plot(correct{i}, 'g');
        title(['Decision boundary for sub-band ' num2str(band)]);
        xlabel('Frame no.')
        ylabel('Log energy [dB]')
        legend('Signal energy', 'Speech mean (HLP)', 'Speech mean (GMM)', 'HLP VAD boundary', 'GMM VAD boundary', 'HLP VAD flag', 'GMM VAD flag', 'Transcript', 'Location', 'NorthWest')
    end
end