%%% THIS SCRIPT REQUIRES THAT RESULT VARIABLES ARE LOADED IN ADVANCE!
%%% .MAT-FILES ARE GENERATED WITH THE mainTest-ROUTINE.

plotVersion = 3;
plotDrifting = 0;
sohn = 1;
num_chnl = 8;

mrksz = 10;
lnw = 2;



%%% begin plot:
voteChn = 1:num_chnl;
if plotVersion == 1 || plotVersion == 3
    figure(98)
    plot(tnr(1,:), tpr(1,:), '-bx', 'MarkerEdgeColor','b', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% GMM
    grid on
    hold on
    plot(tnr(2,:), tpr(2,:), '-md', 'MarkerEdgeColor','m', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% HLP
    plot(tnr(3,:), tpr(3,:), '-r*', 'MarkerEdgeColor','r', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% ITU
    if sohn
        plot(tnr(6,:), tpr(6,:), '-gs', 'MarkerEdgeColor','g', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% Sohn
    end
    rotate = [45 45 45 45 45 45 45 45];
    for t = 1:length(voting)
        text(tnr(2,t), tpr(2,t), [num2str(voteChn(t)), ' -->    '], 'Rotation', rotate(t), 'FontSize', 10, 'HorizontalAlignment', 'right', 'VerticalAlignment', 'middle');
    end
    axis([0 1.05 0 1.05])
    %title(['deciGamma=', num2str(deciGamma), ', SNR=', num2str(SNR), ', hlpupd=', num2str(hlpupd), ', vadDecideUpdate=', num2str(VADDECIDEUPDATE), ', SPF=', num2str(SPF), ', threshVector=[', num2str(threshVector), '], weights=[', num2str(weights), ']']);
    %title(['ROC with SNR = ', num2str(SNR), ', transient threshold = [', num2str(threshVector), '], hlpupd = ', num2str(hlpupd), ' and voting = [' num2str(voting), '] and tranAvgLen = ', num2str(tranAvgLen)]);
    xlabel('TNR')
    ylabel('TPR')
    if sohn
        legend('GMM', 'HLP', 'ITU', 'Sohn', 'Location', 'SouthWest');
    else
        legend('GMM', 'HLP', 'ITU', 'Location', 'SouthWest');
    end
    figure(99)
    plot(tnr(4,:), tpr(4,:), '-r+', 'MarkerEdgeColor','r', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% GMMTR
    grid on
    hold on
    plot(tnr(5,:), tpr(5,:), '-ko', 'MarkerEdgeColor','k', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% HLPTR
    rotate = [45 45 45 45 45 45 5 5];
    for t = 1:length(voting)
        text(tnr(5,t), tpr(5,t), ['   <--  ' num2str(threshVector(t))], 'Rotation', rotate(t), 'FontSize', 10, 'HorizontalAlignment', 'left', 'VerticalAlignment', 'middle');
    end
    axis([0 1.05 0 1.05])
    %title(['deciGamma=', num2str(deciGamma), ', SNR=', num2str(SNR), ', hlpupd=', num2str(hlpupd), ', vadDecideUpdate=', num2str(VADDECIDEUPDATE), ', SPF=', num2str(SPF), ', threshVector=[', num2str(threshVector), '], weights=[', num2str(weights), ']']);
    %title(['ROC with SNR = ', num2str(SNR), ', transient threshold = [', num2str(threshVector), '], hlpupd = ', num2str(hlpupd), ' and voting = [' num2str(voting), '] and tranAvgLen = ', num2str(tranAvgLen)]);
    xlabel('TNR')
    ylabel('TPR')
    legend('GMM transientdeteksjon', 'HLP transientdeteksjon', 'Location', 'SouthWest');
end
if plotVersion == 2 || plotVersion == 3
    figure(100)
    subplot(2,1,1)
        plot(voteChn, tnr(1,:), '-bx', 'MarkerEdgeColor','b', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% GMM
        grid on
        hold on
        plot(voteChn, tnr(2,:), '-md', 'MarkerEdgeColor','m', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% HLP
        plot(voteChn, tnr(3,:), '-r*', 'MarkerEdgeColor','r', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% ITU
        if sohn
            plot(voteChn, tnr(6,:), '-gs', 'MarkerEdgeColor','g', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% Sohn
        end
        axis([0 1.05*num_chnl 0 1.05])
        %title(['deciGamma=', num2str(deciGamma), ', SNR=', num2str(SNR), ', hlpupd=', num2str(hlpupd), ', vadDecideUpdate=', num2str(VADDECIDEUPDATE), ', SPF=', num2str(SPF), ', threshVector=[', num2str(threshVector), '], weights=[', num2str(weights), ']']);
        %title(['T(N/P)R vs voting with SNR = ', num2str(SNR), ', transThresh = [', num2str(threshVector), '], hlpupd = ', num2str(hlpupd), ', voting = [' num2str(voting), '] and tranAvgLen = ', num2str(tranAvgLen)]);
        xlabel('Antall delband')
        ylabel('TNR')
        if sohn
            legend('GMM', 'HLP', 'ITU', 'Sohn', 'Location', 'SouthWest');
        else
            legend('GMM', 'HLP', 'ITU', 'Location', 'SouthWest');
        end
    subplot(2,1,2)
        plot(voteChn, tpr(1,:), '-bx', 'MarkerEdgeColor','b', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% GMM
        grid on
        hold on
        plot(voteChn, tpr(2,:), '-md', 'MarkerEdgeColor','m', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% HLP
        plot(voteChn, tpr(3,:), '-r*', 'MarkerEdgeColor','r', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% ITU
        if sohn
            plot(voteChn, tpr(6,:), '-gs', 'MarkerEdgeColor','g', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% Sohn
        end
        axis([0 1.05*num_chnl 0 1.05])
        xlabel('Antall delband')
        ylabel('TPR')
        if sohn
            legend('GMM', 'HLP', 'ITU', 'Sohn', 'Location', 'SouthWest');
        else
            legend('GMM', 'HLP', 'ITU', 'Location', 'SouthWest');
        end
    figure(101)
        subplot(2,1,1)
        plot(threshVector, tnr(4,:), '-r+', 'MarkerEdgeColor','r', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% GMMwTR
        grid on
        hold on
        plot(threshVector, tnr(5,:), '--ko', 'MarkerEdgeColor','k', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% HLPwTR
        axis([0 1.05*threshVector(end) 0 1.05])
        %title(['deciGamma=', num2str(deciGamma), ', SNR=', num2str(SNR), ', hlpupd=', num2str(hlpupd), ', vadDecideUpdate=', num2str(VADDECIDEUPDATE), ', SPF=', num2str(SPF), ', threshVector=[', num2str(threshVector), '], weights=[', num2str(weights), ']']);
        %title(['T(N/P)R vs transient thresholds with SNR = ', num2str(SNR), ', transThresh = [', num2str(threshVector), '], hlpupd = ', num2str(hlpupd), ', voting = [' num2str(voting), '] and tranAvgLen = ', num2str(tranAvgLen)]);
        xlabel('Transientmal-terskel')
        ylabel('TNR')
        legend('GMM transientdeteksjon', 'HLP transientdeteksjon', 'Location', 'SouthWest');
    subplot(2,1,2)
        plot(threshVector, tpr(4,:), '-r+', 'MarkerEdgeColor','r', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% GMMwTR
        grid on
        hold on
        plot(threshVector, tpr(5,:), '--ko', 'MarkerEdgeColor','k', 'MarkerSize', mrksz, 'LineWidth', lnw) %%% HLPwTR
        axis([0 1.05*threshVector(end) 0 1.05])
        xlabel('Transientmal-terskel')
        ylabel('TPR')
        legend('GMM transientdeteksjon', 'HLP transientdeteksjon', 'Location', 'NorthEast');
end

figure(99);axis square
figure(98);axis square

if plotDrifting
    v = find(voting == 0.5); %%% voting threshold that equals 4 sub-bands
    i = 10; %%% random file
    %%%for k = 1:num_chnl
    for k = 3
        band = k; %%% sub-band to investigate
        if hlpupd
            mu_refHLP = mu_transHLP{v,i}(band,2:2:end);
            vari_refHLP = vari_transHLP{v,i}(band,2:2:end);
            std_refHLP = sqrt(vari_transHLP{v,i}(band,2:2:end));
            mu_refGMM = mu_veriGMM{v,i}(band,2:2:end);
            vari_refGMM = vari_veriGMM{v,i}(band,2:2:end);
            std_refGMM = sqrt(vari_veriGMM{v,i}(band,2:2:end));
        else
            mu_refHLP = mu_veriHLP{v,i}(band,2:2:end);
            vari_refHLP = vari_veriHLP{v,i}(band,2:2:end);
            std_refHLP = sqrt(vari_veriHLP{v,i}(band,2:2:end));
            mu_refGMM = mu_veriGMM{v,i}(band,2:2:end);
            vari_refGMM = vari_veriGMM{v,i}(band,2:2:end);
            std_refGMM = sqrt(vari_veriGMM{v,i}(band,2:2:end));
        end

        figure((band-1)*3 + 1)
        %subplot(3,1,1)
        fr_sig = mean(z{v,i});
        hp(1,:) = plot(fr_sig); hold on; hp(2,:) = plot(outhlpVAD{v,i}, 'r'); hp(3,:) = plot(outgmmVad{v,i}, 'k--'); hp(4,:) = plot(correct{i}, 'g');
        hp(5,:) = plot(bdyHLP{v,i}(:, band), 'y--'); hp(6,:) = plot(bdyGMM{v,i}(:, band), 'g--');
        title('VAD decision');
        legend('Signal energy (mean of all bands)', 'HLP VAD', 'GMM VAD', 'Transcript', 'HLP VAD boundary', 'GMM VAD boundary', 'Location', 'NorthWest');
        xlabel('Frame no.')
        ylabel('Log energy [dB]')
        %subplot(3,1,2)
        figure((band-1)*3 + 2)
        hand(1) = plot(z{v,i}(band,:), 'r'); hold on; hand(2) = plot(mu_refHLP, 'k', 'LineWidth', 2); hand(3) = plot(mu_refGMM, 'b', 'LineWidth', 2);
        hand(4) = plot(mu_refHLP - std_refHLP, 'y--'); plot(mu_refHLP + std_refHLP, 'y--'); hand(5) = plot(mu_refGMM - std_refGMM, 'g--'); plot(mu_refGMM + std_refGMM, 'g--'); %%% investigates sub-band given in variable _band_
        title(['Sub-band ' num2str(band)]);
        xlabel('Frame no.')
        ylabel('Log energy [dB]')
        legend(hand, 'Signal energy', 'Speech mean (HLP)', 'Speech mean (GMM)', 'Speech variance (HLP)', 'Speech variance (GMM)', 'Location', 'NorthWest')
        %subplot(3,1,3)
        figure((band-1)*3 + 3)
        plot(z{v,i}(band,:), 'r'); hold on; plot(mu_refHLP, 'k'); plot(mu_refGMM, 'b');
        plot(bdyHLP{v,i}(:, band), 'y--'); plot(bdyGMM{v,i}(:, band), 'g--');
        plot(outhlpVAD{v,i}, 'r'); plot(outgmmVad{v,i}, 'k--'); plot(correct{i}, 'g');
        title(['Decision boundary for sub-band ' num2str(band)]);
        xlabel('Frame no.')
        ylabel('Log energy [dB]')
        legend('Signal energy', 'Speech mean (HLP)', 'Speech mean (GMM)', 'HLP VAD boundary', 'GMM VAD boundary', 'HLP VAD flag', 'GMM VAD flag', 'Transcript', 'Location', 'NorthWest')
    end
end