function [outvad ratio]= transient_detection(probs_1, probs_2, outvad, threshold, tranAvgLen)

% Calcutate the transient feature from the probabilities 
% collected from the GMM VAD algorithm


%%%if nargin == 4 
%%%    thres = varargin{1};
%%%end

%%%global TEST_THRES TEST_LENGTH FEATURE RATIO THRESHOLD

silence_prob = sum(probs_1(1:8,:),1); % Sum the probability from each subband
speech_prob = sum(probs_2(1:8,:),1); % Sum the probability from each subband
ratio = 1./(speech_prob + silence_prob); % calculate the feature
num_frames = length(ratio);

%%%RATIO  = ratio;

%thres = TEST_THRES * mean(ratio);

% ------------------------  TEST  --------------------------------
if threshold >= 1 %%% use ecdf to find threshold if not directly given as input
    thres = threshold;
else
    [f, x] = ecdf(ratio); %%% CDF estimate of ratios so far
    thres = x(find(f > threshold,1)); %%% find the likelihood threshold for transient detection
end
% ------------------------  TEST  --------------------------------
%%%THRESHOLD = thres;

%%% ADDED 2014.04.28
%%%transientLength = 80;
transientLength = tranAvgLen;
speechFlag = 1; %%% the flag used to denote speech in _outvad_
trsp = -1; %%% denotes transient in speech. Consistent with _creatFrameAnnotation_ notation.
trnsp = -2; %%% denotes transient in non-speech; Consistent with _creatFrameAnnotation_ notation.
%%% /ADDED 2014.04.28

counter = 0;
for i = 1 : num_frames
    if ratio(i) > thres % this number %%%(_thres_) is just a random put number
        counter = counter + 1;
        if counter < transientLength
        	if outvad(i) == speechFlag %%% does now consider weither or not speech is present
        		outvad(i) = trsp; 
        	else
            		outvad(i) = trnsp;
            	end
        end
    else
        counter = 0;
    end
end


end
       
